#!/bin/sh

. /etc/script/lib/command.sh

DMS_DIR="/usr/local/AppCentral/sMedioDTCPServer"
DMS_LIBRARY_PATH="$DMS_DIR/lib"
DH_DMS_LIBRARY_FOLDER="/share/Public/sMedioDTCPServer"
PID_FILE="$DMS_DIR/config/sMedioDTCPServer.pid"
WATCHDOG_PID_FILE="$DMS_DIR/config/sMedioDTCPServerWatchdog.pid"
LOG_FILE="$DMS_DIR/config/webui/log.txt"

start_dms ()
{
	stop_dms
    /bin/sh -c "export DH_DEBUG_LOG_FILE='$LOG_FILE';export DH_DMS_LIBRARY_FOLDER='$DH_DMS_LIBRARY_FOLDER';export LD_LIBRARY_PATH='$DMS_LIBRARY_PATH';sleep 3;$DMS_DIR/bin/sMedioDTCPServerWatchdog &"

    counter=20
    while [ $counter -gt 0 ]
    do
        dms_status && break
        let counter=counter-1
        sleep 1
    done    
    dms_status
}

stop_dms ()
{
	# Kill sMedioDTCPServerWatchdog.
    if [ -f "$WATCHDOG_PID_FILE" ] && [ -d /proc/`cat "$WATCHDOG_PID_FILE"` ]
    then
        kill -9 `cat "$WATCHDOG_PID_FILE"`
    fi
	sleep 1
	
	# Kill sMedioDTCPServer.    
    if [ -f "$PID_FILE" ] && [ -d /proc/`cat "$PID_FILE"` ]
    then		
        kill `cat "$PID_FILE"`
		# Wait sMedioDTCPServer clean resource
		counter=20
		while [ $counter -gt 0 ]
		do
			let counter=counter-1
			if [ -d /proc/`cat "$PID_FILE"` ]
			then
				sleep 1
			else
				break;
			fi
		done
		if [ -d /proc/`cat "$PID_FILE"` ]
		then
			kill -9 `cat "$PID_FILE"`
		fi
    fi
	
	#the last step to kill all process if something wrong
	if [ -n "`pidof sMedioDTCPServerWatchdog`" ]
	then
		kill -9 `pidof sMedioDTCPServerWatchdog`
	fi
	if [ -n "`pidof sMedioDTCPServer`" ]
	then
		kill -9 `pidof sMedioDTCPServer`
	fi	
}

dms_status ()
{
    if [ ! -f "$WATCHDOG_PID_FILE" ]
    then
        return 1
    fi
    if [ -d /proc/`cat "$WATCHDOG_PID_FILE"` ]
    then
        return 0
    else
        return 1
    fi
}

case $1 in

	start)
		# start script here
		start_dms
		;;

	stop)
		# stop script here
		stop_dms
		;;

	*)
		echo "usage: $0 {start|stop}"
		exit 1
		;;
		
esac

exit 0
